#include "REG_MA86L104.H"
#include "TYPE.h"
#include "RX.h"
#include "io.h"
#include "i2c.h"
#include "define.h"
#include "delay.h"

/***************************************************
	
***************************************************/
#define INIT_FAIL_TIME 20
#define RX_Chip_ID 0x22

/***************************************************
	
***************************************************/
uchar analog_reg_val[12][4];	//Analog register values,
uchar reg_val[4];           	//Temporatory register values
uchar CtuneBuf[4];
int	deltaf_last;
uchar AfcCnt;

/***************************************************
	RXʼĴ
***************************************************/
code uchar rx_reg_val[53][4] = 
{
0xDF,0xFF,0xFF,0xF8,    //REG0 
0x04,0xd2,0x80,0x57,    //REG1 
0x89,0x90,0xE0,0x28,    //REG2 
0x04,0x22,0x26,0x9F,    //REG3		0x94,0x22,0x46,0x9F, for test mode    //REG3 
0x50,0x88,0x00,0x44,    //REG4 
0x00,0x28,0x03,0x80,    //REG5 
0x5B,0xED,0xFB,0x00,    //REG6		,update REG6[16:13]=0x6-->0xF,140425;
0x1C,0x24,0xC5,0xAA,	//REG7		,update REG7[8]=0-->1,140414;
0xEF,0xF1,0x19,0x4C,    //REG8 
0x08,0x51,0x13,0xA2,  	//REG9		,update REG9[7]=0-->1,140414;
0x00,0x6F,0x00,0x6F,    //REGA 
0x1B,0xD2,0x58,0x63,    //REGB 
0xE4,0x16,0x95,0x22,    //REG10		,Software Ver No:2014/04/16;  chip id:9522
0x00,0x00,0x00,0x00,    //REG11
0x00,0x08,0x00,0xBD,    //REG16
0x00,0x00,0x00,0x00,    //REG17
0x00,0x00,0x00,0x00,    //REG18
0x00,0x44,0x6D,0x60,    //REG19
0x00,0x00,0x32,0xC0,    //REG1A		,updated,140416
0x54,0xb0,0x51,0xeb,    //REG1B	
0x00,0x17,0xFC,0xFA,    //REG1C		
0x00,0x90,0x00,0x80,    //REG1D		default 0x4E,0x00,0x4D,0x00, GPIO3 ָʾ
0x00,0x00,0x00,0x00,    //REG1E
0x00,0x00,0x00,0x00,    //REG1F
0x00,0x00,0x00,0x00,    //REG20
0x00,0x00,0x00,0x00,    //REG21
0x00,0x00,0x00,0x00,    //REG22
0x00,0x00,0x00,0x00,    //REG23
0x00,0x00,0x00,0x00,    //REG24
0x00,0x00,0x00,0x00,    //REG25
0x00,0x00,0x00,0x00,    //REG26
0x00,0x00,0x00,0x00,    //REG27
0x00,0x00,0x00,0x00,    //REG28
0x00,0x00,0x00,0x00,    //REG29
0x00,0x00,0x00,0x00,    //REG2A
0x00,0x00,0x00,0x00,    //REG2B
0x00,0x00,0x00,0x00,    //REG2C
0x00,0x00,0x00,0x00,    //REG2D
0x00,0x00,0x00,0x00,    //REG2E
0x00,0x00,0x00,0x00,    //REG2F
0x00,0x00,0x00,0x00,    //REG30
0x00,0x00,0x00,0x00,    //REG31
0x22,0x82,0x3D,0x38,    //REG32,		for ANT -PIN5  //0x02,0x82,0x3D,0x38, for ANT-PIN6
0x00,0xD7,0xD5,0xF7,    //REG33
0x00,0x00,0x00,0x00,    //REG34
0x00,0x00,0x00,0x00,    //REG35
0x01,0x46,0x02,0x00,    //REG36,		updated,150708 CRC ERROR VERIFY
0x90,0xF6,0xAA,0x29,    //REG37,		updated,140912  AGC Threshold
0x1F,0x80,0x1E,0x07,    //REG38
0x40,0x40,0x40,0x40,    //REG39
0x00,0x00,0x00,0x40,    //REG3A
0x00,0x78,0x64,0x00,    //REG3B
0x00,0x00,0x00,0x00,
};

/***************************************************
	RXʼ
***************************************************/
//Write different initial register values for different chip status.
void Init_RX(void)
{
    uchar i;
    uchar addr;

	for(i=0;i<=INIT_FAIL_TIME;i++)
	{
		DelayMs(20);
		RX_I2C_Read(0x10,reg_val);
		if(reg_val[3] != RX_Chip_ID) continue;
		break;
	}

	if(reg_val[3] != RX_Chip_ID) return;
	
	for(i = 0;i <= 52; i++)
	{  
    	if(i <= 0x0b)
       		addr = i;
       	else if( i <= 0x0d)
       		addr = 4 + i;
		else if( i <= 0x34)
       		addr = 8 + i;
		RX_I2C_Write(addr,&rx_reg_val[i]); 		//rx_reg_val=rx_48k_vband values
	}
	
	DelayMs(20);
	Write_RX_U_Band_RegVal();//rx_u_band values

	RX_Reset_Chip();
	RX_Trigger();
}

/***************************************************
	дRXƵμƵ,(дƵκƵ󣬱Rx_TriggerƵЧ)
***************************************************/
//Write RX U band register values
void Write_RX_U_Band_RegVal(void)
{
	//Ƶ
	analog_reg_val[3][1] &=~0x20;//REG3[21]=0
	analog_reg_val[3][1] |=0x10;//REG3[20]=1
	analog_reg_val[3][2] &=~0xE0;//REG3[15:13]=0
	analog_reg_val[3][2] |= 0x20;//REG3[13]=1			//751MעУС751M
    RX_I2C_Write(0x03,analog_reg_val[3]); 

	analog_reg_val[7][1] |=0x0E;//REG7[19:17]=7
    RX_I2C_Write(0x07,analog_reg_val[7]); 

	analog_reg_val[8][1] &=~0x0C;//REG8[19:18]=0
	analog_reg_val[8][1] |=0x30;//REG8[21:20]=3
    RX_I2C_Write(0x08,analog_reg_val[8]); 
    
	//Ƶ
	reg_val[0] = 0x55;	//700M
	reg_val[1] = 0x78;
	reg_val[2] = 0x1E;
	reg_val[3] = 0xB8;

    RX_I2C_Write(0x1B,reg_val);    
}

/***************************************************
	Reset_chip
***************************************************/
//Reset chip state machine
void RX_Reset_Chip(void)
{
    RX_I2C_Read(0x1a,reg_val);
    reg_val[3] &= ~0x80;			//REG1A[7]=0
    RX_I2C_Write(0x1a,reg_val);
    reg_val[3] |= 0x80;				//REG1A[7]=1
    RX_I2C_Write(0x1a,reg_val); 
}

/***************************************************
	Rx_Trigger
***************************************************/
//RX mode,trigger chip to calibrate
void RX_Trigger(void)
{
    //V1.3 2017-11-30
    //Tune the RF loop LDO voltage to 0x0
    analog_reg_val[6][0] &= ~0xE0;//REG6[31:29]=0
    RX_I2C_Write(0x06,analog_reg_val[6]);
    DelayMs(1);  //At least delay 1ms

    //Enable calibration clock
    analog_reg_val[7][0] |= 0x02;//REG7[25]=1
    RX_I2C_Write(0x07,analog_reg_val[7]);

    //Calibrate RF VCO    
    analog_reg_val[3][1] &= ~0x40;//REG3[22]=0
    RX_I2C_Write(0x03,analog_reg_val[3]);
    analog_reg_val[3][1] |= 0x40;//REG3[22]=1
    RX_I2C_Write(0x03,analog_reg_val[3]); 
    DelayMs(5);  //At least delay 2ms
    
    //Calibrate Digital VCO       
    analog_reg_val[4][0] &= ~0x02; //REG4[25]=0
    RX_I2C_Write(0x04,analog_reg_val[4]);   
    analog_reg_val[4][0] |= 0x02;  //REG4[25]=1
    RX_I2C_Write(0x04,analog_reg_val[4]);  
    
    //Disable calibration clock
    analog_reg_val[7][0] &= ~0x02;//REG7[25]=0
    RX_I2C_Write(0x07,analog_reg_val[7]);   

    //V1.3 2017-11-30
    DelayMs(1);  //At least delay 1ms
    //Load the default RF loop LDO voltage.
    analog_reg_val[6][0] |= 0x40;//REG6[31:29]=0x2
    RX_I2C_Write(0x06,analog_reg_val[6]);

}

/**************************************************************************************
	
***************************************************************************************/
void RX_PreventBoom(void)
{
	uchar fifo_num;
	
	RX_I2C_Read(0x16,reg_val);
    fifo_num = reg_val[1] & 0x3f;	//read REG16[21:16]=audio FIFO count
    if(fifo_num >= 28)
    {
		RX_Force_PhaseUnlock();		//force Lock to UnLock , reset RX state
	}
}
/**************************************************************************************
	 RXǿUnLock,reset RX state
***************************************************************************************/
void RX_Force_PhaseUnlock(void)
{
	RX_I2C_Read(0x32,reg_val);	
	reg_val[3] &= ~0x08;			//cfg_whiten_en = 0
	reg_val[2] &= 0x0f;				//sync_unlock_win = 0,for fast unlock
	RX_I2C_Write(0x32,reg_val);
						
	{
	DelayMs(2);						//ȷôʱڻ2ms
	RX_I2C_Read(0x32,reg_val);
	reg_val[3] &= ~0x10;			//rx_en = 0
	reg_val[2] |= 0x30;				//sync_unlock_win = 3
	RX_I2C_Write(0x32,reg_val);		
	reg_val[3] |= 0x18;				//rx_en = 1,cfg_whiten_en=1
	RX_I2C_Write(0x32,reg_val);
	DelayMs(2);						//ȷôʱڻ2ms
	}

	//RX_PreventBoom();

}
/**************************************************************************************
	ֹRX RFʧ
***************************************************************************************/
void RX_Prevent_RF_UnLock(void)
{	
	RX_I2C_Read(0x15,reg_val);
	if(reg_val[3] & 0x03)			
	{
		RX_Trigger();
	}
}
/***************************************************
	뷢Ƶƫ
***************************************************/
//Calibrate clock frequency
void RX_Cali_Clk(void)
{
    uchar fifo_num,ctune;
    uint temp_val;   
    int	deltaf,x_val;

    RX_I2C_Read(0x16,reg_val);
    RX_I2C_Read(0x1a,CtuneBuf);

    fifo_num = reg_val[1] & 0x3f;//read REG16[21:16]=audio FIFO count
    temp_val = reg_val[2];
    temp_val = temp_val << 8;
    temp_val += reg_val[3];
    temp_val = (temp_val + 16384) & 0x7fff;//remove bit15
    deltaf = temp_val - 16384;
    deltaf = deltaf / 128;//read REG16[14:0]=delta freq,unit is ppm

	if(((deltaf - deltaf_last) >= 2) || ((deltaf - deltaf_last) <= -2))
	{
		deltaf_last = deltaf;
		deltaf = 0;
	}
	else
	{
		deltaf_last = deltaf;
	}

	if((deltaf >= 8) || (deltaf <= -8))
	{
		x_val = deltaf * 3/2;
		AfcCnt = NEED_PHASE_UNLOCK;		//the first time enter fine tuning,force unlock
	}
	else
	{
		if(fifo_num >= 28)
		{
			x_val = 0;	
			AfcCnt = NEED_PHASE_UNLOCK;		//full FIFO,force unlock
		}
		else if(AfcCnt == 4)
		{
			if(fifo_num > 20) x_val = 1;
			else if(fifo_num < 12 && deltaf <= 0) x_val = -1;	//fine tuning,at most tuning 1ppm 
			else x_val = 0;
			AfcCnt = 1;			//default AfcCnt=1
		}
		else
		{
			x_val = 0;
			AfcCnt ++;
		}	
	}

	ctune = CtuneBuf[3] & 0x7f;
	x_val = ctune - x_val;

	if(x_val > 127)
        x_val = 0x7f;
    else if(x_val < 0)
        x_val = 0x0;  
	
    CtuneBuf[3] = (CtuneBuf[3] & 0x80) | (x_val&0x7f);   //update crystal capacitors

}
/**************************************************************************************
	Ƶʸ
***************************************************************************************/
void RX_Frequency_Tracking(void)
{
	RX_I2C_Read(0x19,reg_val);     
   	reg_val[3] = RX_INTS_SYM_INT1;		//clear the symbot interrupt INT1
    //reg_val[3] |= RX_INTS_SYM_INT1;		//clear the symbot interrupt INT1
    RX_I2C_Write(0x19,reg_val); 	
	
	DelayMs(2);							//ȷôʱڻ2ms
	if(IRQ)								//interrupt INT1
	{
		RX_Cali_Clk();
		RX_I2C_Write(0x1a,CtuneBuf); 	//Update_Ctune
	}
	else
	{
		AfcCnt = 1;
	}

	if(AfcCnt == NEED_PHASE_UNLOCK)
	{
		AfcCnt = 1;
		RX_Force_PhaseUnlock();
	}	
}

/***************************************************
	28K
***************************************************/
/*
//Write RX 28K sample rate register values
void Write_RX_28k_RegVal(void)
{
	analog_reg_val[9][3] |=0x04;//REG9[2]=1
	RX_I2C_Write(0x09,analog_reg_val[9]); 
		
	RX_I2C_Read(0x1A,reg_val);
	reg_val[2] |= 0x01;				//REG1A[8]=1
	RX_I2C_Write(0x1A,reg_val);

	RX_I2C_Read(0x32,reg_val);
	reg_val[3] |= 0x02;				//REG32[1]=1
	RX_I2C_Write(0x32,reg_val);
}
*/
/**************************************************************************************
	GPIO4ΪͨIOڣ
***************************************************************************************/
/*
void RX_GPIO4_IO_High(void)
{
	RX_I2C_Read(0x3A,reg_val);
	reg_val[3] = 0x02;
	RX_I2C_Write(0x3A,reg_val);	
}
*/
/**************************************************************************************
	GPIO4ΪͨIOڣ
***************************************************************************************/
/*
void RX_GPIO4_IO_Low(void)
{
	RX_I2C_Read(0x3A,reg_val);
	reg_val[3] = 0x00;
	RX_I2C_Write(0x3A,reg_val);	
}
*/
/**************************************************************************************
	GPIO4Ϊڶ :Phase Lock
***************************************************************************************/
/*
void RX_GPIO4_2nd_Function(void)
{
	RX_I2C_Read(0x3A,reg_val);
	reg_val[3] = 0x40;
	RX_I2C_Write(0x3A,reg_val);	
}
*/
/**************************************************************************************
	RXƵʹ
***************************************************************************************/
/*
void RX_Audio_Output_Enable(void)
{
	RX_I2C_Read(0x1c,reg_val);	
	reg_val[1] |= 0x10;		//Reg0x1c [20]=1;audio_out_en=1;
	RX_I2C_Write(0x1c,reg_val);
}
*/
/**************************************************************************************
	RXƵر
***************************************************************************************/
/*
void RX_Audio_Output_Disable(void)
{
	RX_I2C_Read(0x1c,reg_val);	
	reg_val[1] &= ~0x10;		//Reg0x1c [20]=1;audio_out_en=1;
	RX_I2C_Write(0x1c,reg_val);	
}
*/
/**************************************************************************************
	ȡRX״̬1:  0: Ͽ
***************************************************************************************/
/*
uchar Read_RX_PhaseLock_Status(void)
{
	uchar phase_lock;

	RX_I2C_Read(0x19,reg_val);
	phase_lock = reg_val[3] & 0x20;

	if(phase_lock) phase_lock = 1;
	else phase_lock = 0;

	return phase_lock;
}
*/
/**************************************************************************************
	ȡRX RFźǿ
***************************************************************************************/
/*
uchar Read_RX_RF_RSSI(void)
{	
	RX_I2C_Read(0x19,reg_val);
	
	return(reg_val[1]);
}
*/		
/**************************************************************************************
	ȡRX Ƶֵ
***************************************************************************************/
/*
uint Read_RX_Audio_RSSI(void)
{
	uint audio_rssi;

	RX_I2C_Read(0x12,reg_val);	
	audio_rssi = reg_val[2] << 8;
	audio_rssi = audio_rssi|reg_val[3];

	return audio_rssi;
}
*/
/**************************************************************************************
	ȡRX ͨϢ
***************************************************************************************/
/*
uchar Read_RX_UserData(void)
{
	RX_I2C_Read(0x19,reg_val);		//read specific data
	
	return(reg_val[2]);
}
*/
/**************************************************************************************
	RX ID
***************************************************************************************/
/*
void Write_RX_ID(uchar id_dat)
{
	reg_val[0] = 0x00;
	reg_val[1] = 0x00;
	reg_val[2] = 0x00;
	reg_val[3] = id_dat;

	RX_I2C_Write(0x34,reg_val);
}
*/
/**************************************************************************************
	RX  volume_tempΧ0~31  ; 0: -24dB;1: -23dB;;31: 7dB
***************************************************************************************/
/*
void Set_RX_Volume(uchar volume_temp)
{
	if(volume_temp > 31) volume_temp = 31;

	RX_I2C_Read(0x1C,reg_val);
	reg_val[3] &= ~0x1F;
	reg_val[3] |= volume_temp;
	RX_I2C_Write(0x1C,reg_val);
}
*/
/**************************************************************************************
	RXģʽڶȡRXıƵ flag_test = 1:ģʽ flag_test = 0:˳ģʽ
***************************************************************************************/
/*
void RX_Test_Mode(uchar flag_test)
{
	if(flag_test)
	{
		RX_I2C_Read(0x03,reg_val);
		reg_val[0] |= 0x90;
		RX_I2C_Write(0x03,reg_val);
	}
	else
	{
		RX_I2C_Read(0x03,reg_val);
		reg_val[0] &= ~0x90;
		RX_I2C_Write(0x03,reg_val);
	}
}
*/
/***************************************************
	I2C_Write
***************************************************/
void RX_I2C_Write(uchar reg,uchar *pBuf)
{
	uchar i;

	if(reg <= 0x0b)       //Analog registers saved by analog_reg_val[][] for read operation
    {
        analog_reg_val[reg][0] = pBuf[0];
        analog_reg_val[reg][1] = pBuf[1];
        analog_reg_val[reg][2] = pBuf[2];
        analog_reg_val[reg][3] = pBuf[3];
    }

	Start_I2C();
	SendByte(RX_Chip_ID);

	reg = reg<<1;
	SendByte(reg);

	for(i=0;i<4;i++)
	{
		SendByte(pBuf[i]);
	}
	Stop_I2C();
		
}

/***************************************************
	I2c_Read
***************************************************/
void RX_I2C_Read(uchar reg,uchar *pBuf)
{
	uchar i;

	if(reg <= 0x0b)         //Analog registers not read directly from chip,recalled from analog_reg_val[][] 
    {
	    pBuf[0] = analog_reg_val[reg][0];
        pBuf[1] = analog_reg_val[reg][1];
        pBuf[2] = analog_reg_val[reg][2];
        pBuf[3] = analog_reg_val[reg][3];
    }
	else
	{
		Start_I2C();
		SendByte(RX_Chip_ID);
		
		reg = reg<<1;
		reg |= 0x01;
		SendByte(reg);

		for(i=0;i<(4-1);i++)
		{
			pBuf[i] = RcvByte();
			I2C_Ack();
		}
		pBuf[i] = RcvByte();
		I2C_Non_Ack();
		Stop_I2C();
	}
}




