#include "REG_MA86L104.H"
#include "TYPE.h"
#include "IO.H"
#include "delay.h"
#include "main.h"
#include "define.h"


bit	ack;
#define i2c_delay 0

/***************************************************
	I2C
***************************************************/
void Start_I2C(void)
{
	if(channel == CHANNEL_1)
	{
		SCK1 = 1;
		Delayus(i2c_delay);
		SDA1 = 1;
		Delayus(i2c_delay);
		SDA1 = 0;
		Delayus(i2c_delay);
		SCK1 = 0;
		Delayus(i2c_delay);	
	}
	else
	{
		SCK2 = 1;
		Delayus(i2c_delay);
		SDA2 = 1;
		Delayus(i2c_delay);
		SDA2 = 0;
		Delayus(i2c_delay);
		SCK2 = 0;
		Delayus(i2c_delay);	
	}		
}
/***************************************************
	I2C
***************************************************/
void Stop_I2C(void)
{
	if(channel == CHANNEL_1)
	{
		SDA1 = 0;
		Delayus(i2c_delay);
		SCK1 = 1;
		Delayus(i2c_delay);
		SDA1 = 1;
		Delayus(i2c_delay);	
	}
	else
	{
		SDA2 = 0;
		Delayus(i2c_delay);
		SCK2 = 1;
		Delayus(i2c_delay);
		SDA2 = 1;
		Delayus(i2c_delay);	
	}
}
/***************************************************
	һֽ
***************************************************/
void SendByte(uchar dat)
{
	uchar i;

	if(channel == CHANNEL_1)
	{
		for(i=0;i<8;i++)
		{
			if((dat << i) & 0x80) SDA1 = 1;
			else SDA1 = 0;
			Delayus(i2c_delay);
			SCK1 = 1;
			Delayus(i2c_delay);
			SCK1 = 0;
			//Delayus(i2c_delay);
		}
		SDA1 = 1;
		Delayus(i2c_delay);
		SCK1 = 1;
		Delayus(i2c_delay);
		if(SDA1 == 1) ack = 0;
		else ack = 1;
		SCK1 = 0;
		Delayus(i2c_delay);
	}
	else
	{
		for(i=0;i<8;i++)
		{
			if((dat << i) & 0x80) SDA2 = 1;
			else SDA2 = 0;
			Delayus(i2c_delay);
			SCK2 = 1;
			Delayus(i2c_delay);
			SCK2 = 0;
			//Delayus(i2c_delay);
		}
		SDA2 = 1;
		Delayus(i2c_delay);
		SCK2 = 1;
		Delayus(i2c_delay);
		if(SDA2 == 1) ack = 0;
		else ack = 1;
		SCK2 = 0;
		Delayus(i2c_delay);
	}	
}
/***************************************************
	һֽ
***************************************************/
uchar RcvByte(void)
{
	uchar dat = 0;
	uchar i;

	if(channel == CHANNEL_1)
	{
		SDA1 = 1;
		for(i=0;i<8;i++)
		{
			SCK1 = 0;
			Delayus(i2c_delay);
			Delayus(i2c_delay);
			SCK1 = 1;
			Delayus(i2c_delay);
			dat = dat<<1;
			if(SDA1 == 1) dat = dat|0x01;
		}
		SCK1 = 0;
		Delayus(i2c_delay);
	}
	else
	{
		SDA2 = 1;
		for(i=0;i<8;i++)
		{
			SCK2 = 0;
			Delayus(i2c_delay);
			Delayus(i2c_delay);
			SCK2 = 1;
			Delayus(i2c_delay);
			dat = dat<<1;
			if(SDA2 == 1) dat = dat|0x01;
		}
		SCK2 = 0;
		Delayus(i2c_delay);
	}
	
	return dat;	
}
/***************************************************
	Ӧ
***************************************************/
void I2C_Ack(void)
{
	if(channel == CHANNEL_1)
	{
		SDA1 =0;
		Delayus(i2c_delay);
		SCK1 = 1;
		Delayus(i2c_delay);
		SCK1 = 0;
		Delayus(i2c_delay);
	}
	else
	{
		SDA2 =0;
		Delayus(i2c_delay);
		SCK2 = 1;
		Delayus(i2c_delay);
		SCK2 = 0;
		Delayus(i2c_delay);
	}
}
/***************************************************
	Ӧ
***************************************************/
void I2C_Non_Ack(void)
{
	if(channel == CHANNEL_1)
	{
		SDA1 = 1;
		Delayus(i2c_delay);
		SCK1 = 1;
		Delayus(i2c_delay);
		SCK1 = 0;
		Delayus(i2c_delay);
	}
	else
	{
		SDA2 = 1;
		Delayus(i2c_delay);
		SCK2 = 1;
		Delayus(i2c_delay);
		SCK2 = 0;
		Delayus(i2c_delay);
	}
}


