#include "REG_MA86L104.H"
#include "TYPE.h"
#include "io.h"
#include "delay.h"
#include "tx.h"
#include "i2c.h"

/**************************************************************************************
	
***************************************************************************************/
#define	TX_Chip_ID 			0x21
#define INIT_FAIL_TIME 		20


/**************************************************************************************
	
***************************************************************************************/
uchar analog_reg_val[12][4];		//Analog register values,
uchar reg_val[4];           		//Temporatory register values
uchar bak_reg_val[4];



//TX Ĵʼ
code uchar tx_reg_val[48][4] =
{
0x1C,0x44,0x0C,0x88,    //REG0
0x04,0xCF,0x00,0x57,    //REG1 
0x89,0x90,0xE0,0x2F,    //REG2 
0xB4,0x22,0x46,0xFF,    //REG3 	,update REG9[28],[31]=0-->1,140414;
0x51,0x88,0x00,0x44,    //REG4 
0x00,0x28,0x03,0x80,    //REG5 
0x5B,0xED,0xFB,0x00,    //REG6 
0x1C,0x40,0x00,0x00,    //REG7 
0x00,0x08,0x01,0x00,    //REG8	,updated,140416
0x00,0x00,0x00,0x03,    //REG9 
0x05,0x8C,0x30,0x30,    //REGA	,update REG9[27:25]=0-->2,140414; 书
0x00,0x06,0xC3,0xFF,    //REGB
0xE4,0x16,0x95,0x21,    //REG10
0x34,0xB0,0x02,0x91,    //REG11
0x00,0x00,0x00,0x40,    //REG12
0x00,0x00,0x00,0x00,    //REG13
0x00,0x00,0x00,0x00,    //REG19
0x00,0x00,0x52,0xC0,    //REG1A	,update REG1A[12]=0-->1;2015-11-2
0x53,0x02,0x00,0x00,    //REG1B
0x04,0x02,0x03,0xFF,    //REG1C
0x58,0x02,0x6C,0x02,    //REG1D
0x0b,0x4b,0x32,0x1b,    //REG1E
0x00,0x00,0x00,0x80,    //REG1F
0x00,0x00,0x93,0xA0,    //REG20
0x00,0xD7,0xD5,0xF7,    //REG21
0x00,0x00,0x00,0x00,    //REG22
0x7F,0x7F,0x00,0xA0,    //REG23
0x00,0x00,0x70,0x50,    //REG25
0x0F,0x80,0x1E,0x04,    //REG26
0x40,0x40,0x40,0x40,    //REG27
0x00,0x00,0x00,0x40,    //REG28
0x03,0xF0,0x64,0x00,    //REG29
0x01,0x00,0x00,0x00,    //REG30
0x07,0x05,0x04,0x02,    //REG31
0x12,0x0F,0x0C,0x0A,    //REG32
0x22,0x1E,0x1A,0x16,    //REG33
0x35,0x30,0x2B,0x26,    //REG34
0x4B,0x45,0x40,0x3A,    //REG35
0x63,0x5D,0x57,0x51,    //REG36
0x7C,0x76,0x70,0x69,    //REG37
0x96,0x8F,0x89,0x83,    //REG38
0xAE,0xA8,0xA2,0x9C,    //REG39
0xC5,0xBF,0xBA,0xB4,    //REG3A
0xD9,0xD4,0xCF,0xCA,    //REG3B
0xE9,0xE5,0xE1,0xDD,    //REG3C
0xF5,0xF3,0xF0,0xED,    //REG3D
0xFD,0xFB,0xFA,0xF8,    //REG3E
0xFF,0xFF,0xFF,0xFE,    //REG3F
};

/**************************************************************************************
	TXʼ
***************************************************************************************/
//Write different initial register values for different chip status.
void Init_TX(void)
{
    uchar i;
    uchar addr;

	for(i=0;i<=INIT_FAIL_TIME;i++)
	{
		DelayMs(20);
		TX_I2C_Read(0x10,reg_val);
		if(reg_val[3] != TX_Chip_ID) continue;
		break;
	}

	if(reg_val[3] != TX_Chip_ID) return;
	
	for(i = 1;i <= 48; i++)
	{  
       if(i <= 12)
          addr = i-1;
       else if( i <= 16)
          addr = 3 + i;
       else if( i <= 27)
          addr = 8 + i;
       else if( i <= 32)
          addr = 9 + i;       
       else if( i <= 48)
          addr = 15 + i;       
       TX_I2C_Write(addr,&tx_reg_val[i-1]);  //tx_reg_val=tx_48k_vband values
    }

	Write_TX_U_Band_RegVal();	//tx_u_band values
	TX_Reset_Chip();
    TX_Trigger();
}

/**************************************************************************************
	TX RFǷʧ
***************************************************************************************/
void TX_Prevent_RF_UnLock(void)
{
	TX_I2C_Read(0x19,reg_val);
	if(reg_val[3] & 0x0c)				//ʧ
	{
    	TX_Trigger();
	}
}
/**************************************************************************************
	дƵμƵ
***************************************************************************************/
//Write TX U band register values
void Write_TX_U_Band_RegVal(void)
{
	analog_reg_val[3][1] &=~0x20;//REG3[21]=0
	analog_reg_val[3][1] |=0x10;//REG3[20]=1
	analog_reg_val[3][2] &=~0xE0;//REG3[15:13]=0
	
	analog_reg_val[3][2] |=0x20;//REG3[15:13]=1	// ƵС751MУƵʴڻ751Mע
	
    TX_I2C_Write(0x03,analog_reg_val[3]); 


	//ƵãοdatasheetƵ㷨
	reg_val[0] = 0x55;
	reg_val[1] = 0x73;
	reg_val[2] = 0x00;
	reg_val[3] = 0x00;		//700MHz
	
    TX_I2C_Write(0x1B,reg_val);      
}
/**************************************************************************************
	Reset_chip
***************************************************************************************/
//Reset chip state machine
void TX_Reset_Chip(void)
{
    TX_I2C_Read(0x1a,reg_val);
    reg_val[3] &= ~0x80;//REG1A[7]=0
    TX_I2C_Write(0x1a,reg_val);
    reg_val[3] |= 0x80;//REG1A[7]=1
    TX_I2C_Write(0x1a,reg_val); 
}

/**************************************************************************************
	Tx_Trigger
***************************************************************************************/
//TX mode,trigger chip to calibrate
void TX_Trigger(void)
{
    //Save default output power to backup
    bak_reg_val[0] = analog_reg_val[10][0]; 
    bak_reg_val[1] = analog_reg_val[10][1]; 
    bak_reg_val[2] = analog_reg_val[10][2]; 
    bak_reg_val[3] = analog_reg_val[10][3]; 
    
    //Set output power=low for tx_trigger
   	analog_reg_val[10][3] = 0x00; //REGA[7:0]=0
    TX_I2C_Write(0x0a,analog_reg_val[10]);   

    //Set ddf_en=0 for tx_trigger
	TX_I2C_Read(0x1f,reg_val);
	reg_val[3] &= ~0x80;//REG1F[7]=0
	TX_I2C_Write(0x1f,reg_val);

    //Set tx_en=0 for tx_trigger
	TX_I2C_Read(0x20,reg_val);
	reg_val[3] &= ~0x80;//REG20[7]=0
	TX_I2C_Write(0x20,reg_val);	

    //Enable calibration clock
    analog_reg_val[7][0] |= 0x02;   //REG7[25]=1
    analog_reg_val[7][0] &= ~0x10; //REG7[28]=0
    TX_I2C_Write(0x07,analog_reg_val[7]);     

    //Calibrate RF VCO 
    analog_reg_val[3][1] &= ~0x40; //REG3[22]=0
    TX_I2C_Write(0x03,analog_reg_val[3]);
	analog_reg_val[3][1] |= 0x40;   //REG_0x3[22]=1
    TX_I2C_Write(0x03,analog_reg_val[3]); 
    DelayMs(50);  //At least delay 30ms

    //Calibrate Digital VCO    
    analog_reg_val[4][0] &= ~0x02;//REG4[25]=0
    TX_I2C_Write(0x04,analog_reg_val[4]);   
    analog_reg_val[4][0] |= 0x02;  //REG4[25]=1
    TX_I2C_Write(0x04,analog_reg_val[4]);  

    //Disable calibration clock
    analog_reg_val[7][0] &= ~0x02;//REG7[25]=0
    analog_reg_val[7][0] |= 0x10; //REG7[28]=1 
    TX_I2C_Write(0x07,analog_reg_val[7]); 

    //Set ddf_en=1 for normal mode
	TX_I2C_Read(0x1f,reg_val);
	 reg_val[3] |= 0x80;//REG1F[7]=1
	TX_I2C_Write(0x1f,reg_val);

    //Set tx_en=1 for normal mode
	TX_I2C_Read(0x20,reg_val);
	 reg_val[3] |= 0x80;//REG20[7]=1
	TX_I2C_Write(0x20,reg_val);

    //Recall default output power
    TX_I2C_Write(0x0a,bak_reg_val); 
}


/**************************************************************************************
	дͨ
***************************************************************************************/
/*
void Write_TX_UserData(uchar dat)
{
	reg_val[0] = 0x00;
	reg_val[1] = 0x00;
	reg_val[2] = dat;
	reg_val[3] = 0xA0;
	TX_I2C_Write(0x20,reg_val);
}
*/
/**************************************************************************************
	д TX ID
***************************************************************************************/
/*
void Write_TX_ID(uchar id_dat)
{
	reg_val[0] = 0x00;
	reg_val[1] = 0x00;
	reg_val[2] = 0x00;
	reg_val[3] = id_dat;
	TX_I2C_Write(0x22,reg_val);
}
*/
/**************************************************************************************
	TX뵥زģʽ  flag_test1:TX뵥زģʽ flag_test=0:TX˳زģʽ
***************************************************************************************/
/*
void TX_Test_Mode(uchar flag_test)
{
	if(flag_test)						//TX뵥زģʽ
	{
		TX_I2C_Read(0x09,reg_val);
		reg_val[1] |= 0x20;
		TX_I2C_Write(0x09,reg_val);	
	}
	else								//TX˳زģʽֵģʽ
	{
		TX_I2C_Read(0x09,reg_val);
		reg_val[1] &= ~0x20;
		TX_I2C_Write(0x09,reg_val);
	}
}
*/
/**************************************************************************************
	TX = volume_temp/2
***************************************************************************************/
/*
void Set_TX_Volume(uchar volume_temp)
{
	uchar temp1;
	uchar temp2;

	if(volume_temp > 95) volume_temp = 95;
	
	temp1 = volume_temp/12;
	temp2 = volume_temp%12;
	temp2 = temp2 <<4;

	TX_I2C_Read(0x1E,reg_val);
	reg_val[0] = (reg_val[0] & 0xf8)|temp1;
	reg_val[1] = (reg_val[1] & 0x0f)|temp2;
	TX_I2C_Write(0x1E,reg_val);	
}
*/
/**************************************************************************************
	28K //Write TX 28K sample rate register values
***************************************************************************************/
/*
void Write_TX_28k_RegVal(void)
{
	analog_reg_val[0][0]=0x10;//REG0=0x10000008
	analog_reg_val[0][1]=0X00;
	analog_reg_val[0][2]=0X00;
	analog_reg_val[0][3]=0X08;
    TX_I2C_Write(0x00,analog_reg_val[0]); 

	analog_reg_val[8][1] |=0x04;//REG8[18]=1
    TX_I2C_Write(0x08,analog_reg_val[8]); 

	TX_I2C_Read(0x1A,reg_val);
	reg_val[2] |= 0x01;				//REG1A[8]=1
	TX_I2C_Write(0x1A,reg_val);

	TX_I2C_Read(0x20,reg_val);
	reg_val[3] |= 0x08;				//REG20[3]=1
	TX_I2C_Write(0x20,reg_val);
}
*/
/**************************************************************************************
	TX I2Cд
***************************************************************************************/
void TX_I2C_Write(uchar reg,uchar *pBuf)
{
	uchar i;

	if(reg <= 0x0b)       //Analog registers saved by analog_reg_val[][] for read operation
    {
        analog_reg_val[reg][0] = pBuf[0];
        analog_reg_val[reg][1] = pBuf[1];
        analog_reg_val[reg][2] = pBuf[2];
        analog_reg_val[reg][3] = pBuf[3];
    }

	Start_I2C();
	SendByte(TX_Chip_ID);

	reg = reg<<1;
	SendByte(reg);

	for(i=0;i<4;i++)
	{
		SendByte(pBuf[i]);
	}
	Stop_I2C();
		
}


/**************************************************************************************
	TX I2C
***************************************************************************************/
void TX_I2C_Read(uchar reg,uchar *pBuf)
{
	uchar i;

	if(reg <= 0x0b)         //Analog registers not read directly from chip,recalled from analog_reg_val[][] 
    {
	    pBuf[0] = analog_reg_val[reg][0];
        pBuf[1] = analog_reg_val[reg][1];
        pBuf[2] = analog_reg_val[reg][2];
        pBuf[3] = analog_reg_val[reg][3];
    }
	else
	{
		Start_I2C();
		SendByte(TX_Chip_ID);
		
		reg = reg<<1;
		reg |= 0x01;
		SendByte(reg);

		for(i=0;i<(4-1);i++)
		{
			pBuf[i] = RcvByte();
			I2C_Ack();
		}
		pBuf[i] = RcvByte();
		I2C_Non_Ack();
		Stop_I2C();
	}
}







